﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace RowNumberingIssue
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.ultraGrid1.DataSource = GetData();
            // the rows selector numbers would appear in the correct order
            this.ultraGrid1.DisplayLayout.Override.RowSelectorNumberStyle = RowSelectorNumberStyle.VisibleIndex;
            // the rows selector numbers would appear in the order thet have been added to the grid 
            //this.ultraGrid1.DisplayLayout.Override.RowSelectorNumberStyle = RowSelectorNumberStyle.RowIndex;
        }

        public DataTable GetData()
        {


            string[] names = { "Peter", "Maria", "John", "Vladimir", "Gustavo" };

            DataTable ct = new DataTable("CustomersTable");
            var keys = new DataColumn[1];

            ct.Columns.Add("CustomerID", typeof(int));
            ct.Columns.Add("Name", typeof(string));
            ct.Columns.Add("Date", typeof(DateTime));

            for (int i = 0; i < 5; i++)
            {
                var row = ct.Rows.Add();
                row[0] = i + 1;
                row[1] = names[i%5];
                row[2] = DateTime.Now.AddDays(i * 2);
            }
            keys[0] = ct.Columns["CustomerID"];

            ct.PrimaryKey = keys;

            return ct;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string[] names = { "Peter", "Maria", "John", "Vladimir", "Gustavo" };

            //DataTable dt = this.ultraGrid1.DataSource as DataTable;
            //DataRow row = dt.NewRow();
            //row[0] = dt.Rows.Count +1;
            //row[1] = names[(dt.Rows.Count+1) % 5];
            //row[2] = DateTime.Now.AddDays((dt.Rows.Count +1)* 2);


            //dt.Rows.InsertAt(row, 3);
            UltraGridRow row = this.ultraGrid1.DisplayLayout.Bands[0].AddNew();
            row.Cells[0].Value = ultraGrid1.Rows.Count +1;
            row.Cells[1].Value = names[(ultraGrid1.Rows.Count + 1) % 5];
            row.Cells[2].Value = DateTime.Now;
           
            row.ParentCollection.Move(row, 3);
            this.ultraGrid1.ActiveRowScrollRegion.ScrollRowIntoView(row);
        }
    }
}
